#include <string.h>
#include <stddef.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <io.h>

#include "modsetup.h"

#include "shockexe.h"

menuitem mainmenu[] = {
  {
    /* menu title */
    "Main Menu",
    /* subheader (green) */
    "Current Filename ( SHOCK.EXE )",
    /* total menu items (this not included) */
    5
  },
  {
    /* menu item name */
    "Hacks setup",
    /* menu item hint */
    "Configure various hacks.",
    /* menu item flag */
    0
  },
  {
    "Advertisement",
    "Some related advertisement. Check it out!",
    0
  },
  {
    "About DeHacker",
    "Information about this program.",
    0
  },
  {
    "Save settings and exit",
    "Save the current settings and exit.",
    0
  },
  {
    "Exit without saving settings",
    "Exit without saving any changes.",
    0
  }
};

menuitem maininfo[] = {
  {"About DeHacker", NULL, 8 | MENU_NFOBOX},
  {"Creature Shock DeHacker Version 1.0", NULL, 0},
  {"(c) -=CHE@TER=- 2020", NULL, 0},
  {"e-mail: _CTPAX_@MAIL.RU", NULL, 0},
  {"http://ctpax-cheater.losthost.org/htmldocs/trouble.htm", NULL, 0},
  {"", NULL, 0},
  {"Compatibility fixes for DOS and old Windows games and software.", NULL, 0},
  {"Hiring? Offering a one-time job? Paid requests are always welcome!", NULL, 0},
  {"Contact for more details.", NULL, 0}
};

menuitem mainexit[] = {
  {"Save settings?", NULL, 2 | MENU_DLGBOX},
  {"Yes", "Save current settings and exit program.", 0},
  {"No", "Do not save current settings, but exit program.", 0}
};

static menuitem mainmisc[] = {
  {"Advertisement", NULL, 17 | MENU_NFOBOX},
  {"Introducing Reviver, a patch for the game Scorcher (1996, Zyrinx/Scavenger).", NULL, 0},
  {"Some of the Scorcher Reviver features:", NULL, 0},
  {"* support for retro gaming PCs and modern systems - you can run Reviver", NULL, 0},
  {"  on anything from Windows 98 to Windows 10 or even under *nix with Wine", NULL, 0},
  {"* screen resolution not limited to 640x480 anymore, fullscreen and", NULL, 0},
  {"  new windowed borderless fullscreen mode", NULL, 0},
  {"* fully configurable gamepad / joystick / game controller, usable in menu", NULL, 0},
  {"* new challenging game modes: Survival, Insanity and Speedrun", NULL, 0},
  {"* streaming music from wave-files - CD disc not required to play", NULL, 0},
  {"* fixes to improve gameplay experience such as auto use 1st person view", NULL, 0},
  {"* a lot of original bugs patched like non saved highscores and settings", NULL, 0},
  {"* partial modding support with external files and much, much more!", NULL, 0},
  {"Try it now with the demo version of the game:", NULL, 0},
  {"https://games.softpedia.com/get/Patch/Scorcher-Reviver.shtml", NULL, ITEM_GRAYED},
  {"Or win a free registration key for Reviver (see topic page 37 for details):", NULL, 0},
  {"https://forum.speeddemosarchive.com/post/cash_bounties_for_speedruns361.html", NULL, ITEM_GRAYED},
  {"(c) SysTools 2018-2020 Reviver is only a patch, game itself required to run.", NULL, 0}
};

int MenuProc(int item) {
  switch (item) {
    /* hacks */
    case 1:
      MenuHacks();
      SetMenuData(mainmenu[item], 1);
      break;
    /* misc */
    case 2:
      DrawMenu(mainmisc, NULL);
      break;
    /* about */
    case 3:
      DrawMenu(maininfo, NULL);
      break;
    /* exit */
    case 4:
    case 5:
      item = 0;
      break;
  }
  return(item);
}

int main(void) {
int i;
  /* startup */
  InitSetup(maininfo[1].item, maininfo[2].item);
  /* if no game executables found */
  if (!LoadHacks()) {
    /* disable hacks menu items */
    mainmenu[0].hint = NULL; /* hide subheader */
    mainmenu[1].flag |= ITEM_GRAYED; /* disable hacks menu */
    mainmenu[4].flag |= ITEM_GRAYED; /* disable save changes menu */
  }
  /* show main menu */
  i = DrawMenu(mainmenu, MenuProc);
  /* if save changes or yes in additional menu */
  if ((GetMenuData(mainmenu[1])) && ((i == 4) || ((i == 0) && (DrawMenu(mainexit, NULL) == 1)))) {
    /* save patches */
    SaveHacks();
  }
  /* cleanup */
  FreeSetup();
  return(0);
}
